<?xml version="1.0" encoding="UTF-8"?>
<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:mvc="http://www.springframework.org/schema/mvc"
	xmlns:context="http://www.springframework.org/schema/context" xmlns:tx="http://www.springframework.org/schema/tx"
	xmlns:mybatis="http://mybatis.org/schema/mybatis-spring"
	xsi:schemaLocation="http://www.springframework.org/schema/mvc http://www.springframework.org/schema/mvc/spring-mvc-4.0.xsd
		http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans.xsd
		http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-4.0.xsd
		   http://mybatis.org/schema/mybatis-spring http://mybatis.org/schema/mybatis-spring.xsd
		http://www.springframework.org/schema/context http://www.springframework.org/schema/context/spring-context-4.0.xsd">

<!-- 	<mvc:annotation-driven /> -->
	<mvc:resources mapping="/resources/**" location="classpath:/resources" />
	<import resource="classpath:dsImport.xml" />
	<context:property-placeholder location="classpath:*.properties"/>
	<context:component-scan base-package="com.freecharge" />
<!-- 	<bean id = "appConfig" class="com.freecharge.config.AppConfig"/> -->
	
	<bean id="mysqlDatasource" class="org.apache.commons.dbcp.BasicDataSource">
		<property name="driverClassName" value="com.mysql.jdbc.Driver"/>
		<property name="defaultAutoCommit" value="true"/>
		<property name="poolPreparedStatements" value="false"/>
		<property name="initialSize" value="${datasource.initialSize}"/>
		<property name="maxActive" value="${datasource.maxActive}"/>
		<property name="maxWait">
			<bean class="java.lang.Long">
                <constructor-arg index="0" value="86400000"/>
            </bean>
        </property>
		<property name="maxIdle">
			<bean class="java.lang.Long">
                <constructor-arg index="0" value="200"/>
            </bean>
        </property>
		<property name="minIdle">
			<bean class="java.lang.Long">
                <constructor-arg index="0" value="100"/>
            </bean>
		</property>
		<property name="timeBetweenEvictionRunsMillis">
			<bean class="java.lang.Long">
                <constructor-arg index="0" value="34000"/>
            </bean>
		</property>
		<property name="minEvictableIdleTimeMillis" value="55000"/>
		<property name="validationQuery" value="SELECT 1"/>
		<property name="testOnBorrow" value="true"/>
		<property name="testWhileIdle" value="true"/>
		<property name="url" value="${database.url}"/>
		<property name="username" value="${database.userName}"/>
		<property name="password" value="${database.password}"/>
	</bean>
	
	<bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean">
		<property name="dataSource" ref="mysqlDatasource" />
		<property name="configLocation" value="classpath:spring/sqlmap-config.xml" />
	</bean>
	
	<bean id="sqlSession" class="org.mybatis.spring.SqlSessionTemplate">
		<constructor-arg index="0" ref="sqlSessionFactory" />
		<constructor-arg index="1" value="SIMPLE" />
	</bean>

	<bean id="mysqlTransactionManager"
		class="org.springframework.jdbc.datasource.DataSourceTransactionManager">
		<property name="dataSource" ref="mysqlDatasource" />
	</bean>

	<bean class="org.mybatis.spring.mapper.MapperScannerConfigurer">
		<property name="basePackage"
			value="com.freecharge.dao, com.freecharge.dao.mapper" />
	</bean>
</beans>
